

----------[[[[[[[[[[[[[[[[[[[[[SETTINGS]]]]]]]]]]]]]]]]]]]]]-----------
--files
file = 'koth_nucleus_d.vmf'--name of input file
outfile = 'koth_nucleus_scrambled_2.vmf'--name of output file
readfiles = {--additional files to gather textures and props from
	'cp_gorge_d.vmf',
	'cp_steel_d.vmf',
	'ctf_turbine_d.vmf',
	'arena_granary_d.vmf'
}

--scramble features
scrambletextures = true--scramble surface textures?
scrambleoverlays = true--scramble overlay textures?
scramblelights = true--scramble light colors?
scramblerendercolors = true--scramble render colors?
scrambleskins = true--scramble prop skins?
scrambleprops = false--scramble prop models? (usually makes a mess)
scramblesoundscapes = true--scramble proxy soundscapes?
scrambleambient = true--scramble generic ambient audio?
scramblepoints = false--scramble control points? (only for use on maps with multiple control points)

--texture settings
preservepaths = true--If true, dirt roads will not be scrambled.
disablereflectscramble = true--Reduces number of reflective textures produced by scrambling. Great if you just don't like huge reflective textures in your map. Also helps deal with "too many textinfos" errors.
disabledevscramble = false--Avoids scrambling into dev textures.
--color settings
lightvariance = 160--Variance of light/rendercolor colors and brightness (0=no variance, 255 = max variance)
lightsaturation = {0, 1}--Min and max vibrance of colors generated without preset. Scale 0-1.
uselightpresets = false--If true, lights will be picked from a set of colors rather than completely randomized. Results in much more vibrant colors. Overrides lightvariance.
userenderpresets = false--Same as above, but applies to rendercolors rather than lights.
mutepresetcolors = 0--Increase this to make the preset colors less colorful (up to 255).
--prop settings
skinsmax = 4--Number of skins to assume things have for random skin selection (higher numbers mean more variance on things like signs that have lots of skins, but less variance on things that have only a few skins).
limitpropscramble = true--Try to only scramble props that won't completely mess up the map (reccommended).
propscramblechance = 0.5--Scale 0-1. Lower numbers scramble props less often.
getpropsfromotherfiles = false--Gather prop data from readfiles?

--troubleshooting settings
nonrandomtextureshuffle = 0--Scale 0-1. Makes texture scrambling much less random; 1 is entierly not random, 0 is entierly random. Intended to fix "too many textinfos" errors. Can also be used to simply make the map look less chaotic.
nonrandomtextureseed = 11--Set this to different numbers to produce different results from nonrandomtextureshuffle.
texturescramblechance = 1--Scale 0-1. Lower numbers decrease how many textures are shuffled. Reduce this if there is an error regarding too many textinfos, and nonrandomtextureshuffle can't fix it.





makepath = false--ignore this for now (WIP)

--------------------[[[[[[[[[[[[[[[[[[[[[[[[TEXTURE LISTS]]]]]]]]]]]]]]]]]]]]]]]]------------------------------------------------------------------------------------
local texturebanlist = {
	{s="tools/", rw=2, b=true},
	{s="water/", rw=2, b=true},
	{s="no_entry", rw=2, b=true},
	{s="hazard_yellow", rw=2, b=true},
	{s="lights/", rw=2, b=true},
	{s="officedoor", rw=2, b=true},
	{s="dirtroad", rw=0, b=true},
	{s="dirtroad", rw=1, b=preservepaths},
	{s="sprites/", rw=2, b=true},
	{s="props/", rw=2, b=true},
	{s="models/props", rw=2, b=true},
	{s="particle/", rw=2, b=true},
	{s="skybox", rw=2, b=true},
	{s="reflect", rw=0, b=disablereflectscramble},
	{s="chrome", rw=0, b=disablereflectscramble},
	{s="dev/", rw=0, b=disabledevscramble}
}
local texturecatlist = {}
texturecatlist[1]={
	{s="overlays/", rw=2, b=true},
	{s="dirtroad", rw=1, b=true}
}
texturecatlist[2]={
	{s="glass/", rw=2, b=true},
	{s="metalgrate", rw=2, b=true},
	{s="metalrail", rw=2, b=true},
	{s="razorwire", rw=2, b=true},
	{s="chicken_wire", rw=2, b=true},
	{s="truss", rw=2, b=true}
}
texturecatlist[3]={
	{s="signs/", rw=2, b=true},
	{s="decals/", rw=2, b=true}
}
local texturecattype = {}
texturecattype[1] = 0
texturecattype[2] = 1
texturecattype[3] = 0
texturecattype[4] = 1
--------------------[[[[[[[[[[[[[[[[[[[[[[[[MODEL LISTS]]]]]]]]]]]]]]]]]]]]]]]]------------------------------------------------------------------------------------
local propbanlist = {
	"skybox",
	"gameplay/",
	"bomb_cart",
	"gibs",
	"nucleus/mp",
	"vent_system",
	"light",
	"ceiling",
	"beam",
	"support",
	"door",
	"frame",
	"explosion",
	"pit_",
	"silhouettes",
	"pipe",
	"stair",
	"rail",
	"substation",
	"barrier",
	"time_card_rack",
	"forest",
	"rock",
	"blast_furnace",
	"mining/track_",
	"fence",
	"sewer",
	"train_flatcar",
	"train_tankcar",
	"billboard",
	"conveyor",
	"train_loader",
	"wall_map"
}
local propcatlist = {}
propcatlist[1]={--real long big things
	"reel_rack",
	"uniform_locker",
	"bookcase",
	"roof_vent",
	"grain_machinery"
}
propcatlist[2]={--flat wall things
	"computer_wall",
	"chalkboard",
	"corkboard",
	"computer_industrial",
	"junctionbox",
	"fire_bell"
}
propcatlist[3]={--real big stuff
	"dumptruck",
	"train_engine",
	"tank00",
	"_mining/generator"
}
propcatlist[4]={
	"tree"
}
--------------------[[[[[[[[[[[[[[[[[[[[[[[[COLORS]]]]]]]]]]]]]]]]]]]]]]]]------------------------------------------------------------------------------------
local lightpresets={
	{255, 255, 255},
	{255, 0 + mutepresetcolors, 0 + mutepresetcolors},
	{0 + mutepresetcolors, 255, 0 + mutepresetcolors},
	{0 + mutepresetcolors, 0 + mutepresetcolors, 255},
	{255, 255, 0 + mutepresetcolors},
	{0 + mutepresetcolors, 255, 255},
	{255, 0 + mutepresetcolors, 255},
	{255, 40 + mutepresetcolors, 40 + mutepresetcolors},
	{40 + mutepresetcolors, 255, 40 + mutepresetcolors},
	{40 + mutepresetcolors, 40 + mutepresetcolors, 255},
	{255, 255, 40 + mutepresetcolors},
	{40 + mutepresetcolors, 255, 255},
	{255, 40 + mutepresetcolors, 255}
}
--------------------[[[[[[[[[[[[[[[[[[[[[[[[GROUNDENTS]]]]]]]]]]]]]]]]]]]]]]]]------------------------------------------------------------------------------------

--------------------[[[[[[[[[[[[[[[[[[[[[[[[ACTUAL CODE]]]]]]]]]]]]]]]]]]]]]]]]------------------------------------------------------------------------------------
require("io")
math.randomseed( os.time() )
-- see if the file exists
function file_exists(file)
  local f = io.open(file, "rb")
  if f then f:close() end
  return f ~= nil
end

-- get all lines from a file, returns an empty 
-- list/table if the file does not exist
function lines_from(file)
  if not file_exists(file) then return {} end
  lines = {}
  for line in io.lines(file) do 
    lines[#lines + 1] = line
  end
  return lines
end
--scramble order of items in table t
local function shuffleTable( t )
    local rand = math.random
    assert( t, "shuffleTable() expected a table, got nil" )
    local iterations = #t
    local j
    
    for i = iterations, 2, -1 do
        j = rand(i)
        t[i], t[j] = t[j], t[i]
    end
	
	return t
end
local logfile = io.open("scramblemap.log", "w")--log
--check what category the prop is in, and if it is banned
function GetPropGrouping(s)
	if not limitpropscramble then return 1 end
	for i, b in pairs(propbanlist) do
		if string.find(s, b) ~= nil then
			return 0
		end
	end
	for i, c in pairs(propcatlist) do
		for _, b in pairs(c) do
			if string.find(s, b) ~= nil then
				return i+1
			end
		end
	end
	return 1
end
--check what category the texture is in, and if it is banned
function GetTextureGrouping(s, rw)
	s = string.lower(s)
	if rw == 0 then logfile:write("Getting category for: " .. s .. ", " .. tostring(rw) .. "  ||  ") end
	for i, b in pairs(texturebanlist) do
		if string.find(s, b.s) ~= nil and b.b and (rw == b.rw or b.rw == 2) then
			if rw == 0 then logfile:write("Returned 0, " .. b.s .. ", " .. tostring(b.b) .. ", " .. tostring(b.rw) .. "\n") end
			return 0
		end
	end
	for i, c in pairs(texturecatlist) do
		for _, b in pairs(c) do
			if string.find(s, b.s) ~= nil and b.b and (rw == b.rw or b.rw == 2) then
				if rw == 0 then logfile:write("Returned " .. tostring(i+1) .. ", " .. b.s .. ", " .. tostring(b.rw) .. "\n") end
				return i+1
			end
		end
	end
	if rw == 0 then logfile:write("Returned 1\n") end
	return 1
end

--initialize variables
local wfile = io.open(outfile, "w")--output file

local lines = lines_from(file)--table of all lines from input file
local readlines = {}--table of all lines from both input file and readfiles
local lightbase = 254 - lightvariance--value used in light calculations
local textures = {}--normal textures
--local textures2 = {}--glass and other transparent textures
--local textures3 = {}--overlays
--local textures4 = {}--signs
local props = {}--props
local soundscapes = {}--soundscapes
local ambients = {}--ambient_generic messages
local gotem = {}--keep track of what we've seen already
for i=1, #texturecatlist+1 do--set up props table with empty tables for each category
	textures[i]={}
end
for i=1, #propcatlist+1 do--set up props table with empty tables for each category
	props[i]={}
end
local pointindexes = {}--control point indexes
local pointprintnames = {}--control point names
local entities = {}

--build readlines
if (#readfiles > 0) then
	for i, l in pairs(lines) do
		readlines[#readlines + 1] = l
	end
	for i, f in pairs(readfiles) do
		local newlines = lines_from(f)
		for i, l in pairs(newlines) do
			readlines[#readlines + 1] = l
		end
	end
end

--read lines and gather data
for k,v in pairs(readlines) do
	local fmata = 0
	local fmatb = 0
	local fmoda = 0
	local fmodb = 0
	local fssa = 0
	local fssb = 0
	local faga = 0
	local fagb = 0
	local inoriginalinput = (k <= #lines)
	
	if makepath and #entities > 0 then
		fmata, fmatb = string.find(v, "\"classname\" \"")
		if fmatb ~= nil then
			local s = string.sub(v, fmatb+1, -2)
			if entities[#entities].classname == nil then
				entities[#entities].classname = s
			end
		else
			fmata, fmatb = string.find(v, "\"point_index\" \"")
			if fmatb ~= nil then
				local s = string.sub(v, fmatb+1, -2)
				if entities[#entities].point_index == nil then
					entities[#entities].point_index = tonumber(s)
				end
			else
				fmata, fmatb = string.find(v, "\"origin\" \"")
				if fmatb ~= nil then
					local s = string.sub(v, fmatb+1, -2)
					if entities[#entities].origin == nil then
						entities[#entities].origin = {
						}
						--logfile:write(s .. "\n")
						local spos, spen = string.find(s, " ")
						entities[#entities].origin[1] = tonumber(string.sub(s, 0, spos - 1))
						local spos2, spen2 = string.find(s, " ", spos + 1)
						entities[#entities].origin[2] = tonumber(string.sub(s, spen + 1, spos2 - 1))
						entities[#entities].origin[3] = tonumber(string.sub(s, spen2 + 1))
						--[[
						for _, p in pairs(entities[#entities].origin) do
							logfile:write(tostring(p) .. " ")
						end
						logfile:write("\n")
						]]
					end
				end
			end
		end
	end
	
	fmata, fmatb = string.find(v, "\"material\" \"")
	if fmatb ~= nil then
		local s = string.sub(v, fmatb+1, -2)
		if makepath and #entities > 0 and entities[#entities].material == nil then
			entities[#entities].material = s
		end
		if s ~= nil and not gotem[s] then
			local cat = GetTextureGrouping(s, 0)
			--logfile:write("Cat_r " .. tostring(cat))
			if cat > 0 then
				textures[cat][#textures[cat]+1] = s
			end
			gotem[s]=true
		end
	else
		fmoda, fmodb = string.find(v, "\"model\" \"models/props")
		if scrambleprops and fmodb ~= nil and (getpropsfromotherfiles or inoriginalinput) then
			local s = string.sub(v, fmodb+1, -2)
			if not gotem[s] then
				local cat = GetPropGrouping(s)
				if cat > 0 then
					props[cat][#props[cat]+1] = s
				end
				gotem[s]=true
			end
		else
			fssa, fssb = string.find(v, "\"soundscape\" \"")
			if scramblesoundscapes and fssb ~= nil then
				local s = string.sub(v, fssb+1, -2)
				if not gotem[s] then
					soundscapes[#soundscapes+1] = s
					gotem[s] = true
				end
			else
				faga, fagb = string.find(v, "\"message\" \"")
				if scrambleambient and fagb ~= nil then
					local s = string.sub(v, fagb+1, -2)
					if not gotem[s] then
						ambients[#ambients+1] = s
						gotem[s] = true
					end
				else
					if inoriginalinput then--only do control point stuff if we're reading from the original input file
						faga, fagb = string.find(v, "\"point_index\" \"")
						if scramblepoints and fagb ~= nil then
							local s = string.sub(v, fagb+1, -2)
							pointindexes[#pointindexes+1] = s
						else
							faga, fagb = string.find(v, "\"point_printname\" \"")
							if scramblepoints and fagb ~= nil then
								local s = string.sub(v, fagb+1, -2)
								pointprintnames[#pointprintnames+1] = s
							end
						end
					end
				end
			end
		end
		--wfile:write(v)
		if (v == "entity") then entities[#entities+1] = {} end
	end
end

--scramble point tables
if scramblepoints then
pointindexes = shuffleTable(pointindexes)
pointprintnames = shuffleTable(pointprintnames)
end
local pointcountera = 1

local function OutputScrambledTexture(v, s, fmatb, texturesTable, catType)
	--logfile:write("output " .. v .. ", " .. s .. ", " .. tostring(catType))
	if catType == 0 then
		if scrambletextures and texturescramblechance > math.random() then
			wfile:write(string.sub(v, 1, fmatb))
			if nonrandomtextureshuffle > math.random() then
				local myindex = math.ceil(math.random()*#texturesTable)
				for i, k in pairs(texturesTable) do
					if k == s then myindex = i end
				end
				local w = texturesTable[((myindex + 11) % #texturesTable)+1]
				while w == nil do
					w = texturesTable[math.ceil(math.random()*#texturesTable)]
				end
				wfile:write(w)
				wfile:write("\"")
			else
				local w = texturesTable[math.ceil(math.random()*#texturesTable)]
				while w == nil do
					w = texturesTable[math.ceil(math.random()*#texturesTable)]
				end
				wfile:write(w)
				wfile:write("\"")
			end
		else
			wfile:write(v)
		end
	else
		if scrambleoverlays then
			wfile:write(string.sub(v, 1, fmatb))
			wfile:write(texturesTable[math.ceil(math.random()*#texturesTable)])
			wfile:write("\"")
		else
			wfile:write(v)
		end
	end
end

local function GetVibrance(color)
	return math.abs(math.max(color[1], color[2], color[3]) - math.min(color[1], color[2], color[3])) / 255
end

local function ScrambleColor(p)
	if p then
		local preset = lightpresets[math.ceil(math.random()*#lightpresets)]
		return preset
	else
		local color = {math.ceil(math.random()*lightvariance)+lightbase, math.ceil(math.random()*lightvariance)+lightbase, math.ceil(math.random()*lightvariance)+lightbase}
		local vibrance = GetVibrance(color)
		while vibrance < lightsaturation[1] or vibrance > lightsaturation[2] do
			color = {math.ceil(math.random()*lightvariance)+lightbase, math.ceil(math.random()*lightvariance)+lightbase, math.ceil(math.random()*lightvariance)+lightbase}
			vibrance = GetVibrance(color)
		end
		return color
	end
end

--read through the lines again, writing output to the output file
for k,v in pairs(lines) do
	local fmata = 0
	local fmatb = 0
	local flta = 0
	local fltb = 0
	local fska = 0
	local fskb = 0
	local fmoda = 0
	local fmodb = 0
	local fssa = 0
	local fssb = 0
	local faga = 0
	local fagb = 0
	local frca = 0
	local frcb = 0
	fmata, fmatb = string.find(v, "\"material\" \"")
	if fmatb ~= nil then
		local s = string.sub(v, fmatb+1, -2)
		local cat = GetTextureGrouping(s, 1)
		--logfile:write("Cat " .. tostring(cat))
		if cat > 0 then
			local catType = texturecattype[cat]
			OutputScrambledTexture(v, s, fmatb, textures[cat], catType)
		else
			wfile:write(v)
		end
	else
		flta, fltb = string.find(v, "\"_light\" \"")
		if fltb ~= nil and scramblelights then
			wfile:write(string.sub(v, 1, fltb))
			if uselightpresets then
				local preset = lightpresets[math.ceil(math.random()*#lightpresets)]
				wfile:write(tostring(preset[1]) .. " " .. tostring(preset[2]) .. " " .. tostring(preset[3]) .. " ")
			else
				wfile:write(tostring(math.ceil(math.random()*lightvariance)+lightbase))
				wfile:write(" ")
				wfile:write(tostring(math.ceil(math.random()*lightvariance)+lightbase))
				wfile:write(" ")
				wfile:write(tostring(math.ceil(math.random()*lightvariance)+lightbase))
				wfile:write(" ")
			end
			wfile:write(string.sub(v, -4))
		else
			fska, fskb = string.find(v, "\"skin\" \"")
			if fskb ~= nil and scrambleskins then
				local skinscale = skinsmax
				if tonumber(string.sub(v, fskb+1, -2)) ~= nil and tonumber(string.sub(v, fskb+1, -2)) > skinscale then
					skinscale = tonumber(string.sub(v, fskb+1, -2)) + 2
				end
				wfile:write(string.sub(v, 1, fskb))
				wfile:write(tostring(math.floor(math.random()*skinscale)))
				wfile:write("\"")
			else
				fmoda, fmodb = string.find(v, "\"model\" \"models/props")
				if scrambleprops and fmodb ~= nil then
					local s = string.sub(v, fmodb+1, -2)
					local cat = GetPropGrouping(s)
					if cat > 0 and propscramblechance > math.random() then
						wfile:write(string.sub(v, 1, fmodb))
						wfile:write(props[cat][math.ceil(math.random()*#props[cat])])
						wfile:write("\"")
					else
						wfile:write(v)
					end
				else
					fssa, fssb = string.find(v, "\"MainSoundscapeName\" \"")
					if scramblesoundscapes and fssb ~= nil then
						wfile:write(string.sub(v, 1, fssb))
						wfile:write(soundscapes[math.ceil(math.random()*#soundscapes)])
						wfile:write("\"")
					else
						faga, fagb = string.find(v, "\"message\" \"")
						if scrambleambient and fagb ~= nil then
							wfile:write(string.sub(v, 1, fagb))
							wfile:write(ambients[math.ceil(math.random()*#ambients)])
							wfile:write("\"")
						else
							frca, frcb = string.find(v, "\"rendercolor\" \"")
							if scramblerendercolors and frcb ~= nil then
								wfile:write(string.sub(v, 1, frcb))
								if userenderpresets then
									local preset = lightpresets[math.ceil(math.random()*#lightpresets)]
									wfile:write(tostring(preset[1]) .. " " .. tostring(preset[2]) .. " " .. tostring(preset[3]) .. " ")
								else
									wfile:write(tostring(math.ceil(math.random()*lightvariance)+lightbase))
									wfile:write(" ")
									wfile:write(tostring(math.ceil(math.random()*lightvariance)+lightbase))
									wfile:write(" ")
									wfile:write(tostring(math.ceil(math.random()*lightvariance)+lightbase))
									wfile:write(" ")
								end
								wfile:write("\"")
							else
								faga, fagb = string.find(v, "\"point_printname\" \"")
								if scramblepoints and fagb ~= nil then
									wfile:write(string.sub(v, 1, fagb))
									wfile:write(pointprintnames[pointcountera])
									wfile:write("\"")
									pointcountera = pointcountera + 1
								else
									faga, fagb = string.find(v, "\"caplayout\" \"")
									if scramblepoints and fagb ~= nil then
										wfile:write(string.sub(v, 1, fagb))
										for _, ind in pairs(pointindexes) do
											if _ > 1 then
												if math.random() < 0.33 then wfile:write(",") end
												wfile:write(" ")
											end
											wfile:write(ind)
										end
										wfile:write("\"")
									else
										wfile:write(v)
									end
								end
							end
						end
					end
				end
			end
		end
	end
	wfile:write("\n")
end
--wfile:write("CP3 \n")
wfile:close()